#include <iostream>
#include <fstream> 
#include <cstdlib> 
#include <stdio.h>
#include <math.h> 
#include <windows.h>


using namespace std; 

ofstream outFile; 

LARGE_INTEGER listart;
LARGE_INTEGER listop;

class Node {
	public:
		int x;
		int y;
		int z; 
		Node * l;
		Node * r; 
		Node(): l(NULL), r(NULL), x(0), y(0), z(0) {}
		~Node() {
			if (l) delete l; 
			if (r) delete r;
		}
		void print();
};

Node * root; 

void Node::print(){
	if (l) l->print(); 
	cout << y << ' ';
	if (r) r->print(); 
}

void generatePermutation(int n, int * a){
	for (int i = 0; i < n; i++) a[i]=i;
	for (int i = 0; i < n; i++){
		int t = i + (rand() % (n - i));
		
		int c = a[i]; 
		a[i] = a[t];
		a[t] = c; 
	}
}

void inversionTableLogarithmic(int n, int * a){	
	
	QueryPerformanceCounter(&listart);
	
	root = new Node; 
	root->x = a[0];
	
	int i = 1; 	
	
	while (i < n){
		int key = a[i]; 
		bool b = true; 
		Node * n = root;
		int c  = 0;
		while (b){
			if (key < n->x){
				c = c + 1 + n->z;
				if (n->l) 
					n = n->l;
				else
					b = false;
			} else {
				n->z++;
				if (n->r) 
					n = n->r;
				else
					b = false;				
			}			
		}
		
		if (key < n->x) {
			n->l = new Node; 
			n->l->x = key;
			n->l->y = c;
		} else {
			n->r = new Node; 
			n->r->x = key;
			n->r->y = c;
		}
		
		i++;
		
	}
	
    QueryPerformanceCounter(&listop);	
    outFile << n << '\t' << (listop.QuadPart - listart.QuadPart) << endl;    
	outFile.flush(); 
	delete root; 
}

int main(int argc, char ** argv){
	outFile.open("out.txt"); 

	for (int i = 10; i < 100000; i+=10){
		int n = i;
		int * a = new int[n]; 	

		generatePermutation(n, a); 
		inversionTableLogarithmic(n, a); 
		delete [] a; 
	}
}








